// CertBase.cpp: implementation of the CCertBase class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ASN.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// һڴ淴
void Swap(BYTE* pData, DWORD dwDataLen)
{
    for(DWORD i = 0 ; i < dwDataLen / 2; i++)  
	{  
	    BYTE temp = pData[i];  
	    pData[i] = pData[dwDataLen - i - 1];  
	    pData[dwDataLen - i - 1] = temp;  
	}  
}

// һڴ淴󷵻ڴ
BYTE* SwapClone(BYTE* pData, DWORD dwDataLen)
{
	BYTE* pSwap = new BYTE[dwDataLen];
	int j = 0;
	for(int i = dwDataLen-1; i >= 0; i--)
	{
		pSwap[j]  = pData[i];
		j++;
	}
	return pSwap;

}

// ȡ
CString GetErrorMsg()
{
	LPVOID lpMsgBuf = NULL;
	DWORD dwErr = ::GetLastError();
	::FormatMessage( 
					FORMAT_MESSAGE_ALLOCATE_BUFFER | 
					FORMAT_MESSAGE_FROM_SYSTEM | 
					FORMAT_MESSAGE_IGNORE_INSERTS,
					NULL,
					dwErr,
					MAKELANGID(LANG_ENGLISH, SUBLANG_DEFAULT), // Default language
					(LPTSTR) &lpMsgBuf,
					0,
					NULL 
	);
	CString strMsg;
	
	strMsg.Format("[%0x]%s", dwErr, lpMsgBuf);
	LocalFree( lpMsgBuf );
	return strMsg;
}

// ASNʱתΪϵͳʱ
void ASNTime2SysTime(BYTE* pASNTime, DWORD dwASNTimeLen, SYSTEMTIME& stDT)
{
	if(dwASNTimeLen < 12 || pASNTime == NULL)
		return;
	
	char szTemp[3] = {0};

	memcpy(szTemp, pASNTime, 2);				// 
	stDT.wYear = ::atoi(szTemp)+2000;
	
	memcpy(szTemp, pASNTime+2, 2);				// 
	stDT.wMonth = ::atoi(szTemp);

	memcpy(szTemp, pASNTime+4, 2);				// 
	stDT.wDay = ::atoi(szTemp);
	
	memcpy(szTemp, pASNTime+6, 2);				// Сʱ
	stDT.wHour = ::atoi(szTemp);

	memcpy(szTemp, pASNTime+8, 2);				// 
	stDT.wMinute = ::atoi(szTemp);

	memcpy(szTemp, pASNTime+10, 2);				// 
	stDT.wSecond = ::atoi(szTemp);

	TRACE("%d-%d-%d %d:%d:%d\r\n", stDT.wYear, stDT.wMonth, stDT.wDay, 
			stDT.wHour, stDT.wMinute, stDT.wSecond);
}

// ڴĶ16ַʽʾ
CString DataToHexStr(BYTE* pData, DWORD dwDataLen, LPCTSTR pcszSeparator, BOOL bOrder)
{
	CString cstrHexStr;
	if(bOrder)
	{
		// ˳ʾ
		for(unsigned int i = 0; i < dwDataLen; i++)
		{
			CHAR szHex[5] = {0};  
			sprintf(szHex, "%02x", (BYTE)pData[i]); 
			if(cstrHexStr.IsEmpty())
			{
				cstrHexStr = szHex;
			}
			else
			{
				cstrHexStr =  cstrHexStr + pcszSeparator + szHex;
			}	
		}	
	}
	else
	{
		// ʾ
		for(unsigned int i = dwDataLen - 1; i >= 0; i--)  
		{  
			CHAR szHex[5] = {0};  
			sprintf(szHex, "%02x", (BYTE)pData[i]);  
			if(cstrHexStr.IsEmpty())
			{
				cstrHexStr = szHex;
			}
			else
			{
				cstrHexStr =  cstrHexStr + pcszSeparator + szHex;
			}	
		}  		
	}

	return cstrHexStr;
}

// 16ַתΪ
BYTE* HexStrToBin(const char* pszHexStr, DWORD& dwSize)
{
	// ж
	dwSize = 0;
	if(!pszHexStr)
		return NULL;
	int iHexStrLen = strlen(pszHexStr);
	if(0 == iHexStrLen)
		return NULL;
	int iRest = iHexStrLen % 2;
	
	// 
	dwSize = iHexStrLen / 2 + iRest;
	BYTE* pData = new BYTE[dwSize+1];
	memset(pData, 0, dwSize+1);
	
	BOOL bRest = FALSE;
	for(unsigned int i = 0; i < dwSize; i++)
	{
		char c = 0;
        for (int j = 0; j < 2; j++)
        {
			int iIdx = 2 * i + j;
			if(iIdx >= iHexStrLen)
			{
				bRest = TRUE;
				break;
			}
			char cCurr = pszHexStr[iIdx];
			if ( '0' <= cCurr && '9' >= cCurr )
			{
				c = (c << 4) + (cCurr - '0');
			}
			else if ( 'a' <= cCurr && 'f' >= cCurr )
			{
				c = (c << 4) + (cCurr - 'a' + 10);
			}
			else if ( 'A' <= cCurr && 'F' >= cCurr )
			{
				c = (c << 4) + (cCurr - 'A' + 10);		
			}
			else	// 16ַ
			{
				delete pData;
				return NULL;
			}
        }

        pData[i] = bRest ? c << 4 : c;
	} 
	return pData;
}

BYTE* HexStrToBigData(const char* pszHexStr, DWORD& dwSize)
{
	BYTE* pBytes = HexStrToBin(pszHexStr, dwSize);
	if(NULL == pBytes)
		return NULL;
	int iLen = strlen(pszHexStr);
	if(0 == (iLen % 2))
		return pBytes;

	// ֽƶ4λ
	for(int i = dwSize-1; i >= 1 ; i--)
	{
		BYTE c1 = *(pBytes+i-1);	// ǰһֽ
		BYTE c2 = *(pBytes+i);		// һֽ

		//BYTE c = (0xF0 & (c1 << 4)) + (c2 >> 4);
		// ǰһֽڵĵ4λǺһֽڵĸ4λ
		BYTE c = (c1 << 4) + (c2 >> 4);
		*(pBytes+i) = c;
	}
	// һֽ
	BYTE c = *pBytes;
	c = 0x0F & (c >> 4);
	*pBytes = c;
	return pBytes;
}

// ־
void LogOut(LPCTSTR pszPathFile, const char* pszFormat, ...)
{
	char szBuff [4096] = {0};
    va_list pArgList ;
	va_start (pArgList, pszFormat) ;
    (void)_vsnprintf (szBuff, sizeof (szBuff) / sizeof (char)-1, 
						 pszFormat, pArgList) ;
    va_end (pArgList);

	if(NULL == pszPathFile)
	{
		TRACE("%s", szBuff);
	}
	else
	{
		FILE* pFile = ::fopen(pszPathFile, "a");
		if(pFile)
		{
			::fwrite((void*)(LPCTSTR)szBuff, sizeof(char), strlen(szBuff), pFile);
			::fclose(pFile);
			pFile = NULL;
		}	
	}
}
//////////////////////////////////////////////
// ΪOIDַͶ໥ת
//////////////////////////////////////////////
#define INT128			128
#define INT40			40
#define INT128X128		(INT128*INT128)
#define INT128X128X128	(INT128*INT128*INT128)
static void Division128(DWORD dwData, CByteArray& arrByte)
{
	if(dwData >= INT128X128X128)
	{
		DWORD dwD = dwData / INT128X128X128;
		DWORD dwL = dwData % INT128X128X128;
		BYTE byD = BYTE(0x80 | dwD);		// øλΪ1
		arrByte.Add(byD);
		Division128(dwL, arrByte);	
	}
	else if(dwData >= INT128X128 && dwData < INT128X128X128)
	{
		DWORD dwD = dwData / INT128X128;
		DWORD dwL = dwData % INT128X128;
		BYTE byD = BYTE(0x80 | dwD);		// øλΪ1
		arrByte.Add(byD);
		Division128(dwL, arrByte);
	}
	else if(dwData >= INT128 && dwData < INT128X128)
	{
		DWORD dwD = dwData / INT128;
		DWORD dwL = dwData % INT128;
		BYTE byD = BYTE(0x80 | dwD);		// øλΪ1
		arrByte.Add(byD);
		arrByte.Add(BYTE(dwL));
	}
	else 
	{
		arrByte.Add(BYTE(dwData));	
	}
}
// HexOIDתΪInt
static int HexToOIDInt(const BYTE* pData, int& iLen)
{
	int i = 0;
	BYTE arrByte[4] = {0};				// һ4λ
	for(i = 0; i < 4; i++)
	{	
		BYTE byTemp = *(pData+i);
		if(byTemp < INT128)				// λΪ0ֹ
		{
			arrByte[i] = byTemp;
			break;
		}
		else
		{
			arrByte[i] = byTemp & 0x7F;		
		}
	}

	// ֽƴװΪһ
	iLen = i+1;		// 鳤
	int iRet = 0;
	if(2 == iLen)
	{
		int iRet0 = arrByte[0];
		int iRet1 = arrByte[1];
		iRet =  (iRet0 << 7) + iRet1;
	}
	else if(3 == iLen)
	{
		int iRet0 = arrByte[0];
		int iRet1 = arrByte[1];
		int iRet2 = arrByte[2];
		iRet =  (iRet0 << 14) + (iRet1 << 7) + iRet2;
	}
	else if(4 == iLen)
	{
		int iRet0 = arrByte[0];
		int iRet1 = arrByte[1];
		int iRet2 = arrByte[2];
		int iRet3 = arrByte[3];
		iRet =  (iRet0 << 21) + (iRet1 << 14) + (iRet2 << 7) + iRet3;
	}
		
	return iRet;
}


// OIDַתΪƱ
BYTE* OIDStrToHex(const CString& cstrOID, DWORD& dwOIDSize)
{
	BYTE *pOID;
	dwOIDSize = 0;

	DWORD dwStrLen = cstrOID.GetLength();
	char* pszData = new char[dwStrLen+1];
	::memset(pszData, 0, dwStrLen+1);
	::memcpy(pszData, (LPCTSTR)cstrOID, dwStrLen);

	char seps[]   = ".";
	char* psz = ::strtok(pszData, seps);
	int iIndex = 0;
	CDWordArray arrOID;
	while(psz)
	{
		arrOID.Add(::atoi(psz));
		psz = ::strtok(NULL, seps);
	}

	delete pszData;
	pszData = NULL;
	
	DWORD dwSize = arrOID.GetSize();
	if(dwSize < 2)
		return NULL;
	BYTE by1 = BYTE(arrOID[0] * INT40 + arrOID[1]);

	CByteArray arrOIDS;
	arrOIDS.Add(by1);
	for(DWORD i = 2; i < dwSize; i++)
	{
		CByteArray arrByte;
		Division128(arrOID[i], arrByte);
		for(int j = 0; j < arrByte.GetSize() ; j++)
		{
			arrOIDS.Add(arrByte[j]);
		}
	}

	dwOIDSize = arrOIDS.GetSize();
	pOID = new BYTE[dwOIDSize];
	for(DWORD j = 0; j < dwOIDSize; j++)
	{
		pOID[j] = arrOIDS[j];
	}
	return pOID;
}

// תΪOIDַ("1.2.840.113549.1.1.1")
CString HexToOIDStr(const BYTE* pData, DWORD dwDataSize)
{
	CStringArray arrStr;
	int i = 0;
	for(i = 0; i < (int)dwDataSize; )
	{
		int iLen = 0;
		BYTE byTemp = *(pData+i);
		CString cstr;
		if(0 == i)									// һֽҪֳַʾ
		{
			int iIOS = byTemp / INT40;					
			int iMB =  byTemp % INT40;
			cstr.Format("%d", iIOS);
			arrStr.Add(cstr);
			cstr.Format("%d", iMB);
			arrStr.Add(cstr);
			i++;
		}
		else if(byTemp < INT128)					// ֽڵλΪ1ֱʾ
		{
			cstr.Format("%d", byTemp);
			arrStr.Add(cstr);
			i++;
		}
		else
		{
			// ֽڵλΪ1ҪѰ¸ֽڣֱλΪ0
			int iDataLen = 0;
			int iData = HexToOIDInt(pData+i, iDataLen);
			cstr.Format("%d", iData);			
			arrStr.Add(cstr);
			i+=iDataLen;
		}

	}
	
	// ַƴװ"1.2.840.113549.1.1.1"ʽ
	CString cstrRet;
	for(i = 0; i < arrStr.GetSize(); i++)
	{
		if(0 == i)
		{
			cstrRet += arrStr[i];
		}
		else
		{
			cstrRet = cstrRet + "." + arrStr[i];
		}
	}
	return cstrRet;
}

// ASNļָļ
void OutputASN2File(LPCTSTR lpcszPathFile, CAsnSetX* pNodeSetX, int iLevel)
{
	ASSERT(lpcszPathFile);
	ASSERT(pNodeSetX);
	if(NULL == lpcszPathFile || NULL == pNodeSetX)
	{
		return;
	}

	const CString cstrSeparator = "\t";
	CString cstrSpace;
	for(int i = 0; i < iLevel; i++)
	{
		cstrSpace += cstrSeparator;	
	}

	const int INT_LINENUM = 32;		// ÿʾַ
	BYTE cTag = pNodeSetX->GetTag();
	DWORD dwDataSize = 0;
	DWORD dwTagSize = 0;
	pNodeSetX->GetSize(dwTagSize, dwDataSize);

	LogOut(lpcszPathFile, "%s{0x%02x:%d+%d\n", cstrSpace, cTag, dwDataSize, dwTagSize);
	// ǣɾԭļ

	CTypedPtrList<CPtrList, IAsnNode*>& lstSet = pNodeSetX->GetList();
	
	for(POSITION pos = lstSet.GetHeadPosition(); pos; )
	{
		IAsnNode* pNode = lstSet.GetNext(pos);
		if(pNode->IsStruct())		// ǷΪṹ
		{
			CAsnSetX* pNodeSetX = static_cast<CAsnSetX*>(pNode);
			OutputASN2File(lpcszPathFile, pNodeSetX, iLevel+1);
		}
		else 
		{
			CAsnX* pNodeX = static_cast<CAsnX*>(pNode);
			BYTE* pData = pNodeX->GetData();
			DWORD dwTagSize = pNodeX->GetTagSize();
			DWORD dwDataSize = pNodeX->GetDataSize();
			CString cstrData = DataToHexStr(pData, dwDataSize, "", TRUE);
			char cTag = pNodeX->GetTag();
			// дļ
			LogOut(lpcszPathFile, "\n%s%s[0x%02x:%d+%d]\n", cstrSeparator, cstrSpace, cTag, dwDataSize, dwTagSize);
			if(TAG_OIDOBJ == cTag)
			{
				CString cstrOID = HexToOIDStr(pData, dwDataSize);
				LogOut(lpcszPathFile, "%s%s%s(%s)\n", cstrSeparator, cstrSpace, cstrData, cstrOID);	
			}
			else if((cTag >= 0x12 && cTag <=0x16) || 0xc == cTag)
			{
				char* pStr = new char[dwDataSize+1];
				memcpy(pStr, pData, dwDataSize);
				pStr[dwDataSize] = 0;
				LogOut(lpcszPathFile, "%s%s%s(%s)\n", cstrSeparator, cstrSpace, cstrData, pStr);	
				delete pStr;
			}
			else 
			{
				LogOut(lpcszPathFile, "%s%s", cstrSeparator, cstrSpace);
				for(DWORD iIdx = 1; iIdx <= dwDataSize; iIdx++)
				{
					CHAR szHex[5] = {0};  
					sprintf(szHex, "%02x", (BYTE)pData[iIdx-1]); 
					if(iIdx % INT_LINENUM == 0)
					{
						// һַ
						if(iIdx != dwDataSize)
							LogOut(lpcszPathFile, "%s\n%s%s", szHex, cstrSeparator, cstrSpace);	
						else
							LogOut(lpcszPathFile, "%s", szHex);		
					}
					else
					{
						LogOut(lpcszPathFile, "%s ", szHex);
					}
						
				}
				LogOut(lpcszPathFile, "\n");
			}
		} // end if
	} // end for
	
	LogOut(lpcszPathFile, "%s}%dL\n", cstrSpace, iLevel);
}

// ֵĳȣֵTLVռֽ
static DWORD GetValueSizeByDataLen(DWORD dwDataLen)
{
	DWORD dwValueSize = 0;
	// ݳռеֽ
	if(dwDataLen < 0x7F)			// ֽڣҸλΪ0
	{
		dwValueSize += 1;
	}
	else if(dwDataLen > 0x7F && dwDataLen <= 0xFF)	// ֽڣҸλΪ1
	{
		dwValueSize += 2;
	}
	else if(dwDataLen > 0xFF)	// ˫ֽ
	{
		dwValueSize += 3;
	}

	return dwValueSize;
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////
// class CAsnX δ֪
//////////////////////////////////////////////////////////////////////
BOOL CAsnX::Decode(const BYTE* pBuff)
{
	ASSERT(pBuff);
	if(pBuff == NULL)
		return FALSE;

	m_dwTagSize = 0;
	m_cTag = *pBuff;	
	
	m_dwTagSize++;		// ؼ
	const BYTE* pTag = pBuff+m_dwTagSize;
	if(TAG_BYTE1 == *pTag)				// 0x81Ϊ1ֽ
	{
		m_dwDataSize = *(pTag+1);
		m_dwTagSize+=2;
		
	}
	else if(TAG_BYTE2 == *pTag)			// 0x82Ϊ2ֽ
	{
		WORD wLen = *(WORD*)(pTag+1);	
		m_dwDataSize = SWAP_W16(wLen);
		m_dwTagSize += 3;

	}
	else
	{
		m_dwDataSize = *pTag; 
		m_dwTagSize++;
	}

	
	DWORD dwDataRawSize = m_dwDataSize + m_dwTagSize;
	m_pDataRaw = new BYTE[dwDataRawSize];
	memcpy(m_pDataRaw, pBuff, dwDataRawSize);

	return TRUE;

}

// ¡һASNݵԪ
BOOL CAsnX::Clone(IAsnNode* pNode)
{
	CAsnX* pAsnX = static_cast<CAsnX*>(pNode);
	if(NULL == pAsnX)
		return FALSE;
	
	m_cTag = pAsnX->GetTag();
	m_dwTagSize = pAsnX->GetTagSize();
	m_dwDataSize = pAsnX->GetDataSize();
	delete m_pDataRaw;
	m_pDataRaw = new BYTE[pAsnX->GetDataRawSize()];
	memcpy(m_pDataRaw, pAsnX->GetDataRaw(), pAsnX->GetDataRawSize());

	return TRUE;
}

// ֵ
void CAsnX::SetData(char cTag, DWORD dwDataLen, BYTE* pData)
{
	m_cTag = cTag;	
	delete m_pDataRaw;  m_pDataRaw= NULL;

	m_dwDataSize = dwDataLen;

	// TLV, tagռһֽ
	m_dwTagSize = 1;

	// ݳռеֽ

	m_dwTagSize += GetValueSizeByDataLen(m_dwDataSize);
	
	// ʼֵ
	DWORD dwRawDataSize = m_dwTagSize+m_dwDataSize;
	m_pDataRaw = new BYTE[dwRawDataSize];
	
	*m_pDataRaw = m_cTag;		// Tag
	if(2 == m_dwTagSize)
	{
		*(m_pDataRaw+1) = BYTE(m_dwDataSize);
	}
	else if(3 == m_dwTagSize)
	{
		*(m_pDataRaw+1) = TAG_BYTE1;
		*(m_pDataRaw+2) = BYTE(m_dwDataSize);
	}
	else if(4 == m_dwTagSize)
	{
		*(m_pDataRaw+1) = TAG_BYTE2;
		WORD wValueLen = WORD(m_dwDataSize);
		*(WORD*)(m_pDataRaw+2) = WORD(SWAP_W16(wValueLen));
	}
	if(m_dwDataSize > 0)
		memcpy(m_pDataRaw+m_dwTagSize, pData, m_dwDataSize);
}

//////////////////////////////////////////////////////////////////////
// class CAsnSetX
//////////////////////////////////////////////////////////////////////

void CAsnSetX::Clear()
{
	while(!m_lstSet.IsEmpty())
	{
		delete m_lstSet.RemoveHead();
	}
}

// 
BOOL CAsnSetX::Decode(const BYTE* pBuff)
{
	ASSERT(pBuff);
	if(pBuff == NULL)
		return FALSE;
	
	m_cTag = *pBuff;
	if(!IAsnNode::IsStruct(m_cTag))
		return FALSE;	

	DWORD dwCount = 0;
	DWORD dwTagLen = 0;
	dwTagLen++;		// ؼ

	const BYTE* pTag = pBuff+dwTagLen;
	if(TAG_BYTE1 == *pTag)				// 0x81Ϊ1ֽ
	{
		dwCount = *(pTag+1);
		dwTagLen+=2;
	}
	else if(TAG_BYTE2 == *pTag)			// 0x82Ϊ2ֽ
	{
		WORD wLen = *(WORD*)(pTag+1);	
		dwCount = SWAP_W16(wLen);
		dwTagLen += 3;
	}
	else
	{
		dwCount = *pTag; 
		dwTagLen++;
	}

	const BYTE* pNodeBuff = pBuff + dwTagLen;
	while(dwCount > 0)
	{
		DWORD dwDataSize = 0;
		DWORD dwTagSize = 0;
		if(IAsnNode::IsStruct(*pNodeBuff))
		{
			CAsnSetX* pNode = new CAsnSetX(*pNodeBuff);
			pNode->Decode(pNodeBuff);
			pNode->GetSize(dwTagSize, dwDataSize);
			m_lstSet.AddTail(pNode);
		}
		else
		{
			CAsnX* pNode = new CAsnX();
			pNode->Decode(pNodeBuff);
			
			dwTagSize = pNode->GetTagSize();
			dwDataSize = pNode->GetDataSize();	
			m_lstSet.AddTail(pNode);
		}
		pNodeBuff = pNodeBuff+dwTagSize+dwDataSize;
		dwCount = dwCount - dwTagSize - dwDataSize;
	}

	return TRUE;
}

// ¡һASNݵԪ
BOOL CAsnSetX::Clone(IAsnNode* pNode)
{

	Clear();
	m_cTag = pNode->GetTag();
	CAsnSetX* pSetX = static_cast<CAsnSetX*>(pNode);
	CTypedPtrList<CPtrList, IAsnNode*>& lstSet = pSetX->GetList();

	for(POSITION pos = lstSet.GetHeadPosition(); pos; )
	{
		IAsnNode* pNodeSub = lstSet.GetNext(pos);
		if(pNodeSub->IsStruct())
		{
			CAsnSetX* pNewNode = new CAsnSetX(pNodeSub->GetTag());
			pNewNode->Clone(pNodeSub);
			m_lstSet.AddTail(pNewNode);
		}
		else
		{
			CAsnX* pNewNode = new CAsnX();
			pNewNode->Clone(pNodeSub);
			m_lstSet.AddTail(pNewNode);
		}
	}

	return TRUE;
}

DWORD CAsnSetX::GetSize(DWORD& dwTagSize, DWORD& dwDataSize)
{
	for(POSITION pos = m_lstSet.GetHeadPosition(); pos; )
	{
		IAsnNode* pNode = m_lstSet.GetNext(pos);
		DWORD dwNodeTagSize = 0;
		DWORD dwNodeDataSize = 0;
		
		if(pNode->IsStruct())
		{
			CAsnSetX* pNodeSetX = static_cast<CAsnSetX*>(pNode);
			pNodeSetX->GetSize(dwNodeTagSize, dwNodeDataSize);
		}
		else
		{
			CAsnX* pNodeX = static_cast<CAsnX*>(pNode);	
			dwNodeTagSize = pNodeX->GetTagSize();
			dwNodeDataSize = pNodeX->GetDataSize();
		}
		dwDataSize = dwDataSize + dwNodeTagSize + dwNodeDataSize;
		dwTagSize = GetValueSizeByDataLen(dwDataSize)+1;
	}
	
	return (dwDataSize + dwTagSize);
}

// ȡ
int CAsnSetX::GetDataList(CTypedPtrList<CPtrList, IAsnNode*>& lstData)
{

	for(POSITION pos = m_lstSet.GetHeadPosition(); pos; )
	{
		IAsnNode* pNode = m_lstSet.GetNext(pos);
		if(pNode->IsStruct())	// ǷΪṹ
		{
			CAsnSetX* pNodeSetX = static_cast<CAsnSetX*>(pNode);
			pNodeSetX->GetDataList(lstData);
		}
		else
		{
			lstData.AddTail(pNode);
		}		
	}
	
	return lstData.GetCount();
}

// һݵԪ
IAsnNode* CAsnSetX::AddNode(char cTag, DWORD dwDataLen, BYTE* pData)
{
	if(IAsnNode::IsStruct(cTag))
	{
		CAsnSetX* pNode = new CAsnSetX(cTag);
		m_lstSet.AddTail(pNode);
	}
	else
	{
		CAsnX* pNode = new CAsnX();
		pNode->SetData(cTag, dwDataLen, pData);
		m_lstSet.AddTail(pNode);
	}
	IAsnNode* pNode = m_lstSet.GetTail();
	return pNode;	
}

void CAsnSetX::AddNode(IAsnNode* pNode)
{
	if(pNode)
		m_lstSet.AddTail(pNode);
}

// ȡԭʼ
static DWORD arrLevelSize[256] = {0};	// Ϊ256	
void CAsnSetX::GetRawData(BYTE** pData, DWORD& dwDataLen, int iLevel)
{
	if(iLevel < 0)
	{
		memset(arrLevelSize, 0, 256);
	}
	iLevel++;
	for(POSITION pos = m_lstSet.GetTailPosition(); pos; )
	{
		IAsnNode* pNode = m_lstSet.GetPrev(pos);
		if(pNode->IsStruct())
		{
			CAsnSetX* pNodeSetX = static_cast<CAsnSetX*>(pNode);
			pNodeSetX->GetRawData(pData, dwDataLen, iLevel);
			DWORD dwTagSize =0;
			DWORD dwDataSize = 0;
			arrLevelSize[iLevel] += pNodeSetX->GetSize(dwTagSize, dwDataSize);

//			arrLevelSize[iLevel] += pNodeSetX->GetDataRawSize();
		}
		else
		{
			CAsnX* pNodeX = static_cast<CAsnX*>(pNode);
			BYTE* pNodeDataRaw = pNodeX->GetDataRaw();
			DWORD dwNodeDataRawSize = pNodeX->GetDataRawSize();

			
			// 
			BYTE* pOldData = NULL;
			DWORD dwOldDataLen = dwDataLen;
			if(*pData)
			{
				pOldData = new BYTE[dwOldDataLen];
				memcpy(pOldData, *pData, dwOldDataLen);
				delete *pData; *pData = NULL;
			}
			dwDataLen += dwNodeDataRawSize;	
			*pData = new BYTE[dwDataLen];
			BYTE* pDataRaw = *pData;
			memcpy(pDataRaw, pNodeDataRaw, dwNodeDataRawSize);
			if(pOldData)
				memcpy(pDataRaw+dwNodeDataRawSize, pOldData, dwOldDataLen);
			delete pOldData;

			arrLevelSize[iLevel] += dwNodeDataRawSize;
		}
	}

	DWORD dwDataSetSize = arrLevelSize[iLevel];
	// 
	BYTE* pOldData = NULL;
	DWORD dwOldDataLen = dwDataLen;
	if(*pData)
	{
		pOldData = new BYTE[dwOldDataLen];
		memcpy(pOldData, *pData, dwOldDataLen);
		delete *pData; *pData = NULL;
	}
	DWORD dwTagSize = GetValueSizeByDataLen(dwDataSetSize) + 1;

	// ݺ³
	DWORD dwRawDataSize = dwTagSize + dwDataLen;
	*pData = new BYTE[dwRawDataSize];
	
	BYTE* pDataRaw = *pData;
	*pDataRaw = m_cTag;		// Tag
	if(2 == dwTagSize)
	{
		*(pDataRaw+1) = BYTE(dwDataSetSize);
	}
	else if(3 == dwTagSize)
	{
		*(pDataRaw+1) = TAG_BYTE1;
		*(pDataRaw+2) = BYTE(dwDataSetSize);
	}
	else if(4 == dwTagSize)
	{
		*(pDataRaw+1) = TAG_BYTE2;
		WORD wValueLen = WORD(dwDataSetSize);
		*(WORD*)(pDataRaw+2) = WORD(SWAP_W16(wValueLen));
	}
	
	// ¹	
	if(pOldData)
		memcpy(pDataRaw+dwTagSize, pOldData, dwOldDataLen);
	delete pOldData;
	dwDataLen = dwRawDataSize;

	arrLevelSize[iLevel] = 0;
	iLevel--;
}

