// ASN.h: interface for the 
// ڽASNʽ
// 䣺lig4961@yeah.net
// ߣһֻʷè
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ASN_H__B9638E83_B576_4C14_A268_E01890B9BF58__INCLUDED_)
#define AFX_ASN_H__B9638E83_B576_4C14_A268_E01890B9BF58__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxtempl.h>

// ο
// http://www.cnblogs.com/jintianhu/p/5051169.html
// http://blog.csdn.net/zhoujianhei/article/details/41649803
// http://blog.csdn.net/tuhuolong/article/details/42778945

#define MY_ENCODING_TYPE1  (PKCS_7_ASN_ENCODING | X509_ASN_ENCODING)
#define MY_ENCODING_TYPE2  (PKCS_7_NDR_ENCODING | X509_NDR_ENCODING)

//////////////////////////////////////////////
// ASN1.1 
/*
 ASNݷ࣬ͺͽṹ
 
һTAG
  1Bit8-bit7ʾTAG ֱ֣ͣuniversal(00)application(01)context-specific(10)private(11)
  2Bit6ʾǷΪṹ(1λṹ)0Ǽ͡
  3Bit5-bit1͵TAGֵbit8-bit7Ĳֵͬвͬĺ壬庬±

  Bit8-bit7Ϊuniversal00ʱbit5-bit1ֵʾͬuniversalֵ
  Bit8-bit7Ϊcontext-specific10ʱbit5-bit1ֵʾݣ
  [0] -- ʾ֤İ汾
  [1] -- issuerUniqueIDʾ֤鷢ߵΨһid
  [2] -- subjectUniqueIDʾ֤Ψһid
  [3] -- ʾ֤չֶ

  ṹ룺00100000(0x20)
  
  0x60application0xa0context-specific0xc0private

  1SEQUENCE     0x3000110000
     1.1TAGλUNIVERSAL00
     1.2ڽṹͣ1
     1.2TAGֵΪ1610000
     ͱʾֵֶΪ00110000Ϊ0x30

  2֤չֶΣ0xa010100000
     2.1TAGΪ10
     2.2ṹͣ1
     2.3TAGֵΪ000011
     ͱʾֵֶΪ10100000Ϊ0xa0

Universalͣ1~31
  [01-0x01]		BOOLEAN	[ֵ:falsetrue]
  [02-0x02]		INTEGER	[ֵ]
  [03-0x03]		BIT STRING	[0λλ]
  [04-0x04]		OCTET STRING	[0ֽڻֽ]
  [05-0x05]		NULL	
  [06-0x06]		OBJECT IDENTIFIER	[ӦһĶرʶ]
  [07-0x07]		OBJECT DESCRIPTOR	 [һļ]
  [08-0x08]		EXTERNAL, INSTANCE OF	[ASN.1ûж]
  [09-0x09]		REAL	[ʵֵ]
  [10-0x0a]		ENUMERATED	[ֵбЩÿжصıʶΪASN.1͵һ]
  [11-0x0b]		
  [12-0x0c]		UTF8String	
  [13-0x0d]		RELATIVE-OID	
  [14-0x0e]		
  [14-0x0f]		
  [16-0x10]		SEQUENCE, SEQUENCE OF	[УSEQUENCEÿֵǲͬ͵ģSEQUENCE OF0ͬ]
  [17-0x11]		SET, SET OF	[УSETÿֵǲͬ͵ģSET OF0ͬ]
  [18-0x12]		Numeric String	[09Լո]
  [19-0x13]		Printable String	[A-Za-z0-9ոԼ'()+,-./:=?]
  [20-0x14]		TeletexString, T61String	
  [21-0x15]		VideotexString	
  [22-0x16]		IA5String	
  [23-0x17]		UTCTime	[ͳһȫʱʽ]
  [24-0x18]		GeneralizedTime	
  [25-0x19]		GraphicString	
  [26-0x1a]		VisibleString, ISO646String	
  [27-0x1b]		GeneralString	
  [28-0x1c]		UniversalString	
  [29-0x1d]		CHARACTER STRING	
  [30-0x1e]		BMPString	
  [31-0x1f]		reserved for future use

*/

// TAG
#define CATALOG_UNIVERSAL			0	
#define CATALOG_APPLICATION			1
#define CATALOG_CONTEXT_SPECIFIC	2
#define CATALOG_PRIVATE				3

// universalµĻ
#define TAG_BOOL				0x01		// BOOL
#define TAG_INTEGER				0x02		// 
#define TAG_STR_BIT				0x03		// λַ
#define TAG_STR_OCT				0x04		// ַֽ
#define TAG_NULL				0x05		// 
#define TAG_OIDOBJ				0x06		// ObjectID
//18-220x12-0x16, 25-300x19-0x1e ַ
#define TAG_STR_UTF8			0x12
#define TAG_STR_PRINTABLE		0x13

#define TAG_UTC_TIME			0x17		
#define TAG_SEQUENCE			0x30		// Уһ͵򼯺
#define TAG_SET					0x31		// ϣһ͵򼯺

#define TAG_EXTENTION_A0		0xa0		// ֤汾
#define TAG_EXTENTION_A1		0xa1		// ֤鷢id
#define TAG_EXTENTION_A2		0xa2		// ֤֤id
#define TAG_EXTENTION_A3		0xa3		// ֤չֶ

#define TAG_BYTE1				0x81
#define TAG_BYTE2				0x82


// ߵֽڻ
#define SWAP_W16(w)							\
        ( (((w) & (0xffu << 8)) >> 8)       \
         | (((w) & 0xffu) << 8) )


//////////////////////////////////////////////
// ASN.1ݻTLVʽTag:Length:Value
//////////////////////////////////////////////
class IAsnNode
{
public:
	IAsnNode()	{	};
	virtual ~IAsnNode()	{	};

public:
	virtual BOOL Decode(const BYTE* pBuff) = 0;
	virtual BOOL Clone(IAsnNode* pNode) = 0;
	
	// ȡ
	BYTE	GetTag()		{	return m_cTag;	}
	void	SetTag(BYTE cTag)	{	m_cTag = cTag;	}

	// tagʲô
	BYTE	GetCatalog(){
		BYTE c = (m_cTag & 0xc0) >> 6;		// ȡߵλ
		return c;
	}

	// 00ͨ
	BOOL CatalogIsUniversal(){
		return GetCatalog() == CATALOG_UNIVERSAL;
	}

	// 02Application
	BOOL CatalogIsApplication(){
		return GetCatalog() == CATALOG_APPLICATION;
	}

	// 03context-specific
	BOOL CatalogIsContextSpecific(){
		return GetCatalog() == CATALOG_CONTEXT_SPECIFIC;
	}

	// 04private
	BOOL CatalogIsPrivate(){
		return GetCatalog() == CATALOG_PRIVATE;
	}

	// ǷΪṹ
	BOOL	IsStruct(){
		return IsStruct(m_cTag);
	}

	static	BOOL IsStruct(char cTag){
		return (cTag & 0x20);
	}
protected:
	BYTE		m_cTag;
};

// Ǽͣδַ֪ͣBOOLObj
class CAsnX : public IAsnNode
{	
public:
	CAsnX()	{	
				m_pDataRaw = NULL;
				m_dwDataSize = 0;
				m_dwTagSize = 0;
		};
	virtual ~CAsnX()	{		delete m_pDataRaw;	};

public:
	BOOL	Decode(const BYTE* pBuff);	
	BOOL	Clone(IAsnNode* pNode);

	void	SetData(char cTag, DWORD dwDataLen, BYTE* pData);
	BYTE*	GetData()		{	return (m_pDataRaw+m_dwTagSize);	}
	DWORD	GetDataSize()	{	return m_dwDataSize;	}
	DWORD	GetTagSize()	{	return m_dwTagSize;		}

	BYTE*	GetDataRaw()	{	return m_pDataRaw;	}
	DWORD	GetDataRawSize()	{	return (m_dwDataSize+m_dwTagSize);	}

protected:
	BYTE*	m_pDataRaw;
	DWORD	m_dwDataSize;
	DWORD	m_dwTagSize;
};


// صļ
class CAsnSetX : public IAsnNode
{	
public:
	CAsnSetX(BYTE cTag)	{	
			m_cTag = cTag;
	};
	virtual ~CAsnSetX()	{	Clear();	};

	void Clear();
	
public:
	BOOL	Decode(const BYTE* pBuff);
	BOOL	Clone(IAsnNode* pNode);

	DWORD	GetSize(DWORD& dwTagSize, DWORD& dwDataSize);

	int GetDataList(CTypedPtrList<CPtrList, IAsnNode*>& lstData);
	CTypedPtrList<CPtrList, IAsnNode*>& GetList(){	return m_lstSet;		}

	int GetItemCount(){
		return m_lstSet.GetCount();
	}
	// 
	IAsnNode* AddNode(char cTag, DWORD dwDataLen, BYTE* pData);
	void AddNode(IAsnNode* pNode);

	void GetRawData(BYTE** pData, DWORD& dwDataLen, int iLevel = -1);


// 	DWORD	GetDataSize()	{	return m_dwDataSize;	}
// 	DWORD	GetTagSize()	{	return m_dwTagSize;		}
// 	DWORD	GetDataRawSize()	{	return (m_dwDataSize+m_dwTagSize);	}

protected:
	CTypedPtrList<CPtrList, IAsnNode*> m_lstSet;

// 	DWORD	m_dwDataSize;
// 	DWORD	m_dwTagSize;
	
};

// ⹫
//extern void		LogOut(LPCTSTR pszPathFile, const char* pszFormat, ...);
extern CString	GetErrorMsg();

extern BYTE*	HexStrToBin(const char* pszHexStr, DWORD& dwSize);
extern BYTE*	HexStrToBigData(const char* pszHexStr, DWORD& dwSize);
extern CString	DataToHexStr(unsigned char* pData, DWORD dwDataLen, LPCTSTR pcszSeparator = "", BOOL bOrder = TRUE);

extern CString	HexToOIDStr(const BYTE* pData, DWORD dwDataSize);
extern BYTE*	OIDStrToHex(const CString& cstrOID, DWORD& dwOIDSize);
extern BYTE*	SwapClone(BYTE* pData, DWORD dwDataLen);
extern void		Swap(BYTE* pData, DWORD dwDataLen);
extern void		ASNTime2SysTime(BYTE* pASNTime, DWORD dwASNTimeLen, SYSTEMTIME& stDT);
#endif // !defined(AFX_CERTBASE_H__B9638E83_B576_4C14_A268_E01890B9BF58__INCLUDED_)
