// ASNFileParse.h: interface for the CASNFileParse class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ASNFILEPARSE_H__A306BA8E_355C_4B14_BF3D_BCDA83BB5CFC__INCLUDED_)
#define AFX_ASNFILEPARSE_H__A306BA8E_355C_4B14_BF3D_BCDA83BB5CFC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

///////////////////////////////////////////////
// PEMʽͷβ
///////////////////////////////////////////////
//  PEMʽ
#define STATUS_PEM_NONE		0
#define STATUS_PEM_BEGIN	1
#define STATUS_PEM_END		2

#define PH_PROC_TYPE		"Proc-Type"
#define PH_DEK_INFO			"DEK-Info"	
#define PH_ENCRYPTED		"ENCRYPTED"	

#define STR_PEM_BEGIN		"-----BEGIN"
#define STR_PEM_END			"-----END"

#define STR_CERTIFACATE_BEGIN			"-----BEGIN CERTIFICATE-----"
#define STR_CERTIFACATE_END				"-----END CERTIFICATE-----"
#define STR_PRIVKEY_RSA_BEGIN			"-----BEGIN RSA PRIVATE KEY-----"
#define STR_PRIVKEY_RSA_END				"-----END RSA PRIVATE KEY-----"
#define STR_PRIVKEY_PKCS8_BEGIN			"-----BEGIN PRIVATE KEY-----"
#define STR_PRIVKEY_PKCS8_END			"-----END PRIVATE KEY-----"
#define STR_PRIVKEY_PKCS8_EN_BEGIN		"-----BEGIN ENCRYPTED PRIVATE KEY-----"
#define STR_PRIVKEY_PKCS8_EN_END		"-----END ENCRYPTED PRIVATE KEY-----"
#define STR_PUBKEY_BEGIN				"-----BEGIN PUBLIC KEY-----"
#define STR_PUBKEY_END					"-----END PUBLIC KEY-----"

typedef enum
{
	EM_BINARY = 0,					// ƣδ֪ͣ
	EM_CERTIFACATE,					// ֤
	EM_PUBLICKEY,					// Կ
	EM_PRIVATEKEY_PKCS1,			// ˽ԿRSA PKCS1
	EM_PRIVATEKEY_PKCS8,			// ˽ԿPKCS8
	EM_PRIVATEKEY_PKCS8_ENCRYPT,	// ˽ԿPKCS8 
	EM_KEY_PKCS12					// PKCS12
}EM_CERT_TYPE;

class CAsnSetX;
class IAsnNode;
class CAsnX;
class CASNFileParse  
{
public:
	CASNFileParse();
	virtual ~CASNFileParse();

public:

	CAsnSetX* GetAsnSetX(){
		return m_pAsnSet;
	}
	EM_CERT_TYPE GetFileType(){
		return m_emFileType;
	}

	BOOL IsEncryped(){
		return m_bEncrypt;
	}
public:
	
	// ֤顢ԿԿļ
	BOOL LoadFile(LPCTSTR pcszPathFile, LPCTSTR pszPassword = NULL, EM_CERT_TYPE emType = EM_BINARY);

	// PEM
	BOOL LoadPEMData(LPCTSTR pcszData, EM_CERT_TYPE emType, LPCTSTR pszPassword = NULL);

	// ض
	BOOL LoadBinaryData(BYTE* pData, int iDataLen, EM_CERT_TYPE emType, LPCTSTR pszPassword = NULL);


	// ӡASNϢ
	void OutputASN2Buff(char* pBuff, int iBuffSize, int& iBuffPos, CAsnSetX* pNodeSetX, int iLevel = 0);
	BOOL LogOut(char* pBuff, int iBuffSize, int& iBuffPos, const char* pszFormat, ...);

public:
	// PEMе
	BOOL PEM2AsnBinary(const char* pszData, BYTE** pOutData, DWORD& dwOutDataLen, LPCTSTR pszPassword = NULL);
	
	static LPCTSTR GetObjNameByOID(const CString& cstrOID, BOOL bSN = TRUE);


protected:
	EM_CERT_TYPE	m_emFileType;
	CAsnSetX*		m_pAsnSet;
	BOOL			m_bEncrypt;
};

#endif // !defined(AFX_ASNFILEPARSE_H__A306BA8E_355C_4B14_BF3D_BCDA83BB5CFC__INCLUDED_)
