/***********************************************************************************
* name       : ResizableDialog.cpp
* description: Class CResizableDialog File ṩ沼ֹ
*
* copyright  : Ϊ޹˾(Huawei Tech.Co.,Ltd)
* author     : z65497
*
* time       : 6:9:2007 12:40
* histroy    : 2007/9/6 1.00 ʼ汾
***********************************************************************************/

/*!< Ԥͷļ */
#include "stdafx.h"

/*!< ͷļ */
#include "ResizableDialog.h"

/*!< 浽עеĸʽ */
#define	 PROFILE_FMT 		_T( "%d,%d,%d,%d,%d,%d" )
#define	 PROFILE_NUMBER 	6

/*!< 캯ʵ */
CResizableDialog::CResizableDialog()
{
	Construct();
}
CResizableDialog::CResizableDialog(UINT nIDTemplate, CWnd* pParentWnd)
	: CDialog(nIDTemplate, pParentWnd)
{
	Construct();
}
CResizableDialog::CResizableDialog(LPCTSTR lpszTemplateName, CWnd* pParentWnd)
	: CDialog(lpszTemplateName, pParentWnd)
{
	Construct();
}

/*!< ʵ */
CResizableDialog::~CResizableDialog()
{
}

BEGIN_MESSAGE_MAP(CResizableDialog, CDialog)
	ON_WM_GETMINMAXINFO()
	ON_WM_NCHITTEST()
	ON_WM_DESTROY()	
	ON_WM_PAINT()
	ON_WM_SIZE()	
END_MESSAGE_MAP()

/***********************************************************************************
* ǶṩĽӿںʵ
***********************************************************************************/
void CResizableDialog::AddAnchor( HWND hWnd, ANCHOR stTLType, ANCHOR stBRType /*= NOANCHOR*/ )
{
	/*!< аȫ */
	ASSERT( hWnd && ::IsWindow( hWnd ) );
	ASSERT( ::IsChild( *this, hWnd ) );
	ASSERT( NOANCHOR != stTLType );

	/*!< жϿؼ */
	CString strName;
	GetClassName( hWnd, strName.GetBufferSetLength( MAX_PATH ), MAX_PATH );
	strName.ReleaseBuffer();

	/*!< ݿؼͽж */
	if ( "Button" == strName ) // жǷҪˢ¿ͻ
	{
		DWORD dwStyle = GetWindowLong( hWnd, GWL_STYLE );
		if ( dwStyle & BS_GROUPBOX )
		{
			SetWindowLong( hWnd, GWL_STYLE, dwStyle | WS_CLIPSIBLINGS );
		}
	} // end of if ( WC_BUTTON == strName ) ...
	
	/*!< жǷй */
	BOOL bHScroll = FALSE;
	if ( "ListBox" == strName )	
	{
		bHScroll = TRUE;
	} // end of if ( WC_LISTBOX == WC_BUTTON )	 ...
	
	/*!< жǷҪˢ¿ؼ */
	BOOL bRefresh = FALSE;
	if ("Static"  == strName )
	{
		DWORD dwStyle = GetWindowLong( hWnd, GWL_STYLE );
		switch ( dwStyle & SS_TYPEMASK )
		{
		case SS_LEFT:
		case SS_CENTER:
		case SS_RIGHT:
			{
				bRefresh = TRUE;
			}
		default:
			{ }			
		} // end of switch ( dwStyle & SS_TYPEMASK ) ...

		/*!< ǾеͼƬıؼ */
		if ( dwStyle & SS_CENTERIMAGE )
		{
			bRefresh = TRUE;
		}

		/*!< һıؼ */
		if ( ( dwStyle & SS_TYPEMASK ) == SS_SIMPLE )
		{
			bRefresh = FALSE;
		}
	} // end of if ( WC_STATIC == strName ) ...

	/*!< ôںͿؼĴС */
	CRect rcClient, rcControl;
	GetClientRect( &rcClient) ;
	::GetWindowRect( hWnd, &rcControl );
	ScreenToClient( &rcControl );

	/*!< ؼĶ뷽ʽ */
	CSize szTLMargin, szBRMargin;
	if ( NOANCHOR == stBRType )
	{
		stBRType = stTLType;
	}
	szTLMargin.cx = rcControl.left - rcClient.Width() * stTLType.cx / 100;
	szTLMargin.cy = rcControl.top - rcClient.Height() * stTLType.cy / 100;
	szBRMargin.cx = rcControl.right - rcClient.Width() * stBRType.cx / 100;
	szBRMargin.cy = rcControl.bottom - rcClient.Height() * stBRType.cy / 100;

	/*!< ӵ */
	LPSLAYOUT pLayout = new SLAYOUT( hWnd, stTLType, szTLMargin, stBRType, szBRMargin, bHScroll, bRefresh );
	m_lstLayout.AddTail( pLayout );
}

/***********************************************************************************
* name       : RemoveAnchor
* description: Ƴһƶ
* input      : hWnd - ؼ, uCtrlID - ؼID
* output     : NA
* return     : NA
* remark     : z65497
***********************************************************************************/
void CResizableDialog::RemoveAnchor( HWND hWnd )
{
	/*!< вضԪ */
	LPSLAYOUT pLayout = FindLayOut( hWnd );
	if(pLayout)
	{
		POSITION pos = m_lstLayout.Find(pLayout);
		m_lstLayout.RemoveAt(pos);
	}
	
}

/***********************************************************************************
* name       : ShowSizeGrip
* description: Ƿʾ½϶ı䴰ڴСıʶ
* input      : bShowGrip - Ƿʾ
* output     : NA
* return     : NA
* remark     : z65497
***********************************************************************************/
void CResizableDialog::ShowSizeGrip( BOOL bShowGrip )
{
	if ( bShowGrip != m_bShowGrip )
	{
		m_bShowGrip = bShowGrip;
		InvalidateRect( &m_rcGripRect );

	} // end of if ( bShowGrip != m_bShowGrip ) ...
}

/***********************************************************************************
* name       : UpdateGripPos
* description: Gripλ
* input      : NA
* output     : NA
* return     : NA
* remark     : z65497
***********************************************************************************/
void CResizableDialog::UpdateGripPos()
{
	GetClientRect( &m_rcGripRect );

	m_rcGripRect.left = m_rcGripRect.right - m_szGripSize.cx;
	m_rcGripRect.top = m_rcGripRect.bottom - m_szGripSize.cy;
}

/***********************************************************************************
* name       : SetMaximizedRect
* description: ôڸıСķΧ
* input      : NA
* output     : NA
* return     : NA
* remark     : z65497
***********************************************************************************/
void CResizableDialog::SetMaximizedRect( const CRect& rect )
{
	m_bUseMaxRect = TRUE;

	m_ptMaxPos = rect.TopLeft();
	m_ptMaxSize.x = rect.Width();
	m_ptMaxSize.y = rect.Height();
}

/***********************************************************************************
* name       : ResetMaximizedRect
* description: ڴСԭΪĬϴС
* input      : NA
* output     : NA
* return     : NA
* remark     : z65497
***********************************************************************************/
void CResizableDialog::ResetMaximizedRect()
{
	m_bUseMaxRect = FALSE;
}

/***********************************************************************************
* name       : SetMinTrackSize
* description: ôڸıʱ׷ٴڵĴССֵ
* input      : NA
* output     : NA
* return     : NA
* remark     : z65497
***********************************************************************************/
void CResizableDialog::SetMinTrackSize( const CSize& size )
{
	m_bUseMinTrack = TRUE;

	m_ptMinTrackSize.x = size.cx;
	m_ptMinTrackSize.y = size.cy;
}

/***********************************************************************************
* name       : ResetMinTrackSize
* description: ԭ׷ٴڵСֵ
* input      : NA
* output     : NA
* return     : NA
* remark     : z65497
***********************************************************************************/
void CResizableDialog::ResetMinTrackSize()
{
	m_bUseMinTrack = FALSE;
}

/***********************************************************************************
* name       : SetMaxTrackSize
* description: ôڸıʱ׷ٴڵĴСֵ
* input      : NA
* output     : NA
* return     : 
* remark     : z65497
***********************************************************************************/
void CResizableDialog::SetMaxTrackSize(const CSize& size)
{
	m_bUseMaxTrack = TRUE;

	m_ptMaxTrackSize.x = size.cx;
	m_ptMaxTrackSize.y = size.cy;
}

/***********************************************************************************
* name       : ResetMaxTrackSize
* description: ԭ׷ٴڵֵ
* input      : NA
* output     : NA
* return     : NA
* remark     : z65497
***********************************************************************************/
void CResizableDialog::ResetMaxTrackSize()
{
	m_bUseMaxTrack = FALSE;
}

/***********************************************************************************
* name       : EnableSaveRestore
* description: 洰ڵĴСλ´ʱʾ
* input      : pszSection - ֵֶ
*			   pszEntry	- ֵ
* output     : NA
* return     : NA
* remark     : z65497
***********************************************************************************/
void CResizableDialog::EnableSaveRestore( LPCTSTR pszSection, LPCTSTR pszEntry )
{
	m_cstrSection = pszSection;
	m_cstrEntry = pszEntry;

	m_bEnableSaveRestore = TRUE;
	LoadWindowRect();
}

/***********************************************************************************
* ϵͳϢʵֺ
**********************************************************************************/
/***********************************************************************************
* name       : OnInitDialog
* description: ڳʼ
* input      : NA
* output     : NA
* return     : 
* remark     : z65497
***********************************************************************************/
BOOL CResizableDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	/*!< Gripλ */
	UpdateGripPos();

	/*!< ĬϵĴ׷ٴŶ */
	CRect rc;
	GetWindowRect( &rc );
	m_ptMinTrackSize.x = rc.Width();
	m_ptMinTrackSize.y = rc.Height();

	/*!< óʼϱ */
	m_bInitDone = TRUE;

	return TRUE;  
}

/***********************************************************************************
* name       : OnGetMinMaxInfo
* description: ڴСϢ
* input      : NA
* output     : NA
* return     : 
* remark     : z65497
***********************************************************************************/
void CResizableDialog::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	/*!< жϴǷʼ */
	if ( m_bInitDone )
	{
		if ( m_bUseMinTrack )
		{
			lpMMI->ptMinTrackSize = m_ptMinTrackSize;
		} // end of if ( m_bUseMinTrack ) ...

		if ( m_bUseMaxTrack )
		{
			lpMMI->ptMaxTrackSize = m_ptMaxTrackSize;
		} // end of if ( m_bUseMaxTrack ) ...
			
		if ( m_bUseMaxRect )
		{
			lpMMI->ptMaxPosition = m_ptMaxPos;
			lpMMI->ptMaxSize = m_ptMaxSize;
		} // end of if ( m_bUseMaxRect ) ...

	} // end of if ( m_bInitDone ) ...	
}

/***********************************************************************************
* name       : OnSize
* description: ڸıСʱӦ
* input      : NA
* output     : NA
* return     : 
* remark     : z65497
***********************************************************************************/
void CResizableDialog::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	/*!< ж */
	if ( SIZE_MAXHIDE == nType || SIZE_MAXSHOW == nType || SIZE_MINIMIZED == nType )
	{
		return ;
	}

	/*!< ı䴰ڽԪصĲ */
	if ( m_bInitDone )
	{
		ArrangeLayout();
	} // end of if ( m_bInitDone ) ...
}

/***********************************************************************************
* name       : OnPaint
* description: ԻӦ
* input      : NA
* output     : NA
* return     : 
* remark     : z65497
***********************************************************************************/
void CResizableDialog::OnPaint() 
{
	CPaintDC dc(this);

	if ( m_bShowGrip && !IsZoomed() )
	{
		dc.DrawFrameControl( &m_rcGripRect, DFC_SCROLL, DFCS_SCROLLSIZEGRIP );
	} // end of if ( m_bShowGrip && !IsZoomed() ) ...
}

/***********************************************************************************
* name       : OnNcHitTest
* description: ڱ߿Ӧ
* input      : NA
* output     : NA
* return     : 
* remark     : z65497
***********************************************************************************/
LRESULT  CResizableDialog::OnNcHitTest(CPoint point) 
{
	CPoint pt = point;
	ScreenToClient( &pt );

	/*!< жǷGrip */
	if ( m_bShowGrip && m_rcGripRect.PtInRect( pt ) && 0 <= pt.x && 0 <= pt.y )
	{
		return HTBOTTOMRIGHT;
	}
	
	return CDialog::OnNcHitTest(point);
}

/***********************************************************************************
* name       : OnDestroy
* description: ٵӦ
* input      : NA
* output     : NA
* return     : 
* remark     : z65497
***********************************************************************************/
void CResizableDialog::OnDestroy() 
{
	CDialog::OnDestroy();

	/*!< е沼Ԫ */
	RemoveAllAnchors();

	/*!< ǷҪ洰ڵλúʹС */
	if ( m_bEnableSaveRestore )
	{
		SaveWindowRect();
	} // end of if ( m_bEnableSaveRestore ) ...
}

/***********************************************************************************
* ʹõĺ
***********************************************************************************/
/***********************************************************************************
* name       : ArrangeLayout
* description: ıԪصĲ
* input      : NA
* output     : NA
* return     : NA
* remark     : z65497
***********************************************************************************/
void CResizableDialog::ArrangeLayout()
{
	/*!< Grip */
	if ( m_bShowGrip )
	{
		InvalidateRect( &m_rcGripRect );
		UpdateGripPos();
		InvalidateRect( &m_rcGripRect );
	} // end of if ( m_bShowGrip ) ...	

	/*!< ʼ */
	CRect rcClient;
	GetClientRect( &rcClient );
	int iCount = static_cast<int>( m_lstLayout.GetCount() );

	/*!< нԪزֵĿ */
	HDWP hDwp = ::BeginDeferWindowPos( iCount );
	for (POSITION pos = m_lstLayout.GetHeadPosition(); pos; )
	{
		LPSLAYOUT pLayout = m_lstLayout.GetNext(pos);

		/*!< ԪصλúʹС */
		CRect rcOld, rcNew;
		CWnd* pWnd = CWnd::FromHandle( pLayout->hWnd );
		ASSERT( pWnd );
		pWnd->GetWindowRect( &rcOld );
		ScreenToClient( &rcOld );
		/*!< Ͻǵλ */
		rcNew.left = pLayout->szTLMargin.cx + rcClient.Width() * pLayout->sTTLType.cx / 100;
		rcNew.top = pLayout->szTLMargin.cy + rcClient.Height() * pLayout->sTTLType.cy / 100;
		/*!< ½ǵλ */
		rcNew.right = pLayout->szBRMargin.cx + rcClient.Width() * pLayout->sTBRType.cx / 100;
		rcNew.bottom = pLayout->szBRMargin.cy + rcClient.Height() * pLayout->sTBRType.cy / 100;
		/*!< жǷҪƶ */
		if ( !rcNew.EqualRect( &rcOld) ) 
		{
			if ( pLayout->bHScroll ) // жǷй
			{
				int iDiff = rcNew.Width() - rcOld.Width();
				int iMax = pWnd->GetScrollLimit( SB_HORZ );
				int iPos = pWnd->GetScrollPos( SB_HORZ );
				pLayout->bRefresh = FALSE;	
				if ( 0 < iMax && iPos > ( iMax - iDiff ) )
				{
					pLayout->bRefresh = TRUE;
				}
			} // end of if ( stLayout.bHScroll ) ...
	
			/*!< ƶԪصıʶ */
			DWORD dwFlags = SWP_NOZORDER | SWP_NOACTIVATE | SWP_NOREPOSITION;
			if ( rcNew.TopLeft() == rcOld.TopLeft() )
			{
				dwFlags |= SWP_NOMOVE;
			}
			if ( rcNew.Size() == rcOld.Size() )
			{
				dwFlags |= SWP_NOSIZE;
			}
			::DeferWindowPos( hDwp, pLayout->hWnd, NULL, rcNew.left, rcNew.top, 
							  rcNew.Width(), rcNew.Height(), dwFlags );
		} // end of if ( !rcNew.EqualRect( &rcOld) ) ...
	}
	/*!< ƶпؼ */
	::EndDeferWindowPos( hDwp );
	
	/*!< ˢҪˢµĿؼ */

	for (POSITION pos = m_lstLayout.GetHeadPosition(); pos; )
	{
		LPSLAYOUT pLayout = m_lstLayout.GetNext(pos);
		CWnd* pWnd = CWnd::FromHandle( pLayout->hWnd );
		ASSERT( pWnd );
		if ( pLayout->bRefresh )
		{
			pWnd->Invalidate();
			pWnd->UpdateWindow();
		} // end of if ( pLayoutbRefresh ) ...
	} // end of for ( int j = 0; j < iCount; ++j ) ...
}

/***********************************************************************************
* name       : LoadWindowRect
* description: شʾλ
* input      : NA
* output     : NA
* return     : 
* remark     : z65497
***********************************************************************************/
void CResizableDialog::LoadWindowRect()
{
	/*!< ȡӦóProfile */
	CString strData = AfxGetApp()->GetProfileString( m_cstrSection, m_cstrEntry );
	if ( !strData.IsEmpty() )
	{
		/*!< ȡӦó򴰿ڵĲϢ */
		WINDOWPLACEMENT wp;
		ZeroMemory( &wp, sizeof( WINDOWPLACEMENT ) );
		wp.length = sizeof( WINDOWPLACEMENT );
		GetWindowPlacement( &wp );
		RECT& rect = wp.rcNormalPosition;	

		/*!< жϼصֶκõֶǷһ */
		if ( PROFILE_NUMBER == _stscanf( strData, PROFILE_FMT, &rect.left, &rect.top,
							&rect.right, &rect.bottom, &wp.showCmd, &wp.flags ) )
		{
			SetWindowPlacement( &wp );
		}

	} // end of if ( strData.IsEmpty() ) ...
}

/***********************************************************************************
* name       : SaveWindowRect
* description: 洰ڵʾλ
* input      : NA
* output     : NA
* return     : NA
* remark     : z65497
***********************************************************************************/
void CResizableDialog::SaveWindowRect()
{	
	/*!< ȡӦó򴰿ڵĲϢ */
	WINDOWPLACEMENT wp;
	ZeroMemory( &wp, sizeof( WINDOWPLACEMENT ) );
	wp.length = sizeof( WINDOWPLACEMENT );
	GetWindowPlacement( &wp );	
	RECT& rect = wp.rcNormalPosition;

	/*!< ӦóֲϢ */
	CString strData;
	strData.Format( PROFILE_FMT, rect.left, rect.top, rect.right, rect.bottom, wp.showCmd, wp.flags );
	AfxGetApp()->WriteProfileString( m_cstrSection, m_cstrEntry, strData );
}

/***********************************************************************************
* ڲʹúĶ
***********************************************************************************/
/***********************************************************************************
* name       : Construct
* description: 캯бʼ
* input      : NA
* output     : NA
* return     : 
* remark     : z65497
***********************************************************************************/
inline void CResizableDialog::Construct()
{
	m_bInitDone = FALSE;

	m_bUseMinTrack = TRUE;
	m_bUseMaxTrack = FALSE;
	m_bUseMaxRect = FALSE;

	m_bShowGrip = FALSE;

	m_bEnableSaveRestore = FALSE;

	m_szGripSize.cx = GetSystemMetrics(SM_CXVSCROLL);
	m_szGripSize.cy = GetSystemMetrics(SM_CYHSCROLL);
}

/***********************************************************************************
* name       : FindLayOut
* description: ضĲԪ
* input      : HWND - ؼ
* output     : NA
* return     : Listĵ
* remark     : z65497
***********************************************************************************/
CResizableDialog::LPSLAYOUT CResizableDialog::FindLayOut( HWND hWnd )
{
	
	for (POSITION pos = m_lstLayout.GetHeadPosition(); pos; )
	{
		LPSLAYOUT pLayouyt = m_lstLayout.GetNext(pos);
		if ( pLayouyt->hWnd == hWnd )
		{
			return pLayouyt ;
		}
	} // end of for ( ; itLayout != m_lstLayout.end() ...

	return NULL;
}