/***********************************************************************************
* name       : ResizableDialog.h
* description: Class CResizableDialog File ṩ沼ֹ
* note		 : ù಻֧AcitvexؼĽ沼ֿ
*
* copyright  : Ϊ޹˾(Huawei Tech.Co.,Ltd)
* author     : z65497
*
* time       : 6:9:2007 12:40
* histroy    : 2007/9/6 1.00 ʼ汾
***********************************************************************************/

#ifndef __HW_RESIZABLEDIALOG_H__
#define __HW_RESIZABLEDIALOG_H__
           
#include <Afxtempl.h>

#ifdef _UNITTEST_
#define private public
#define protected public
#endif 

/***********************************************************************************
* ANCHORĽṹ
***********************************************************************************/
typedef struct tagANCHOR
{
	int cx;		// ˮƽŰٷֱ
	int cy;		// ֱŰٷֱ

	/*!< 캯 */
	tagANCHOR() {};
	tagANCHOR( int x, int y )
		: cx( x )
		, cy( y )
	{ };

	/*!<  =  */
	tagANCHOR& operator = ( const tagANCHOR& rhs )
	{
		if ( this != &rhs )
		{
			cx = rhs.cx;
			cy = rhs.cy;
		} // end of if ( this != &rhs ) ...
		
		return *this;

	} // end of tagANCHOR& operator = ...

	/*!<  ==  */
	bool operator == ( const tagANCHOR& rhs ) const
	{
		return ( cx == rhs.cx && cy == rhs.cy );
	}

	/*!<  !=  */
	bool operator != ( const tagANCHOR& rhs ) const
	{
		return ( cx != rhs.cx || cy != rhs.cy );
	}

} ANCHOR, *LPANCHOR;

/*!< ͵Ķ */
const ANCHOR
	NOANCHOR( -1, -1 ),
	TOP_LEFT( 0, 0 ), TOP_CENTER( 50, 0 ), TOP_RIGHT( 100, 0 ),
	MIDDLE_LEFT( 0, 50 ), MIDDLE_CENTER( 50, 50 ), MIDDLE_RIGHT( 100, 50 ),
	BOTTOM_LEFT( 0, 100 ), BOTTOM_CENTER( 50, 100 ), BOTTOM_RIGHT( 100, 100 );

/***********************************************************************************
* CResizableDialogʵ 
***********************************************************************************/
class CResizableDialog : public CDialog
{
public:
	/*!< ׼캯 */
	CResizableDialog();
	CResizableDialog( UINT nIDTemplate, CWnd* pParentWnd = NULL );
	CResizableDialog( LPCTSTR lpszTemplateName, CWnd* pParentWnd = NULL );

	/*!< ׼ */
	virtual ~CResizableDialog();

public:
	/***********************************************************************************
	* ǶṩĽӿں
	***********************************************************************************/

	/***********************************************************************************
	* name       : AddAnchor
	* description: һActiveXĿƶ
	* input      : hWnd - ؼ, uCtrlID - ؼID
	*			   stTLType - ϶뷽ʽ
	*			   stBRType - ¶뷽ʽ
	* output     : NA
	* return     : NA
	* remark     : z65497
	***********************************************************************************/	
	void AddAnchor( HWND hWnd, ANCHOR stTLType, ANCHOR stBRType = NOANCHOR );
	void AddAnchor( UINT uCtrlID, ANCHOR stTLType, ANCHOR stBRType = NOANCHOR )
	{
		AddAnchor( ::GetDlgItem( m_hWnd, uCtrlID ), stTLType, stBRType );
	}

	/***********************************************************************************
	* name       : RemoveAnchor
	* description: Ƴһƶ
	* input      : hWnd - ؼ, uCtrlID - ؼID
	* output     : NA
	* return     : NA
	* remark     : z65497
	***********************************************************************************/
	void RemoveAnchor( HWND hWnd );
	void RemoveAnchor( UINT uCtrlID )
	{
		RemoveAnchor( ::GetDlgItem( m_hWnd, uCtrlID ) );
	}

	/***********************************************************************************
	* name       : RemoveAllAnchors
	* description: еĿƶ
	* input      : NA
	* output     : NA
	* return     : NA
	* remark     : z65497
	***********************************************************************************/
	void RemoveAllAnchors()
	{
		while(!m_lstLayout.IsEmpty())
		{
			delete m_lstLayout.RemoveHead();
		}
	}

	/***********************************************************************************
	* name       : ShowSizeGrip
	* description: Ƿʾ½϶ı䴰ڴСıʶ
	* input      : bShowGrip - Ƿʾ
	* output     : NA
	* return     : NA
	* remark     : z65497
	***********************************************************************************/
	void ShowSizeGrip( BOOL bShowGrip );

	/***********************************************************************************
	* name       : UpdateGripPos
	* description: ˢGripλ
	* input      : NA
	* output     : NA
	* return     : NA
	* remark     : z65497
	***********************************************************************************/
	void UpdateGripPos();

	/***********************************************************************************
	* name       : SetMaximizedRect
	* description: ôڸıСķΧ
	* input      : NA
	* output     : NA
	* return     : NA
	* remark     : z65497
	***********************************************************************************/
	void SetMaximizedRect( const CRect& rect );

	/***********************************************************************************
	* name       : ResetMaximizedRect
	* description: ڴСԭΪĬϴС
	* input      : NA
	* output     : NA
	* return     : NA
	* remark     : z65497
	***********************************************************************************/
	void ResetMaximizedRect();

	/***********************************************************************************
	* name       : SetMinTrackSize
	* description: ôڸıʱ׷ٴڵĴССֵ
	* input      : NA
	* output     : NA
	* return     : NA
	* remark     : z65497
	***********************************************************************************/
	void SetMinTrackSize( const CSize& size );

	/***********************************************************************************
	* name       : ResetMinTrackSize
	* description: ԭ׷ٴڵСֵ
	* input      : NA
	* output     : NA
	* return     : NA
	* remark     : z65497
	***********************************************************************************/
	void ResetMinTrackSize();					

	/***********************************************************************************
	* name       : SetMaxTrackSize
	* description: ôڸıʱ׷ٴڵĴСֵ
	* input      : NA
	* output     : NA
	* return     : 
	* remark     : z65497
	***********************************************************************************/
	void SetMaxTrackSize(const CSize& size);

	/***********************************************************************************
	* name       : ResetMaxTrackSize
	* description: ԭ׷ٴڵֵ
	* input      : NA
	* output     : NA
	* return     : NA
	* remark     : z65497
	***********************************************************************************/
	void ResetMaxTrackSize();

	/***********************************************************************************
	* name       : EnableSaveRestore
	* description: 洰ڵĴСλ´ʱʾ
	* input      : pszSection - ֵֶ
	*			   pszEntry	- ֵ
	* output     : NA
	* return     : NA
	* remark     : z65497
	***********************************************************************************/
	void EnableSaveRestore( LPCTSTR pszSection, LPCTSTR pszEntry );	

protected:
	/***********************************************************************************
	* ʹõĺ
	***********************************************************************************/
	/*!< ıԪصĲ */
	void ArrangeLayout();

	/*!< شʾλ */
	void LoadWindowRect();

	/*!< 洰ڵʾλ */
	void SaveWindowRect();		

protected:
	/***********************************************************************************
	* ϵͳϢ
	***********************************************************************************/
	virtual BOOL OnInitDialog();
	afx_msg LRESULT OnNcHitTest(CPoint point);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	
	DECLARE_MESSAGE_MAP()

private:
	/***********************************************************************************
	* ǽԪزֽṹĶ
	***********************************************************************************/
	typedef struct tagLayout
	{
		HWND		hWnd;			// Ԫصľ
		BOOL		bHScroll;		// ͷй
		BOOL		bRefresh;		// ǷҪˢ

		ANCHOR		sTTLType;		// 
		CSize		szTLMargin;		// ϶뷽ʽ

		ANCHOR		sTBRType;		// 
		CSize		szBRMargin;		// ¶뷽ʽ

		/*!< 캯 */
		tagLayout() : hWnd( NULL )
			, bHScroll( FALSE )
			, bRefresh( FALSE )
			, sTTLType( 0, 0 )
			, szTLMargin( 0, 0 )
			, sTBRType( 0, 0 )
			, szBRMargin( 0, 0 )
		{ };
		tagLayout( HWND hwnd, ANCHOR sttlType, SIZE sztlMargin, 
			ANCHOR stbrType, SIZE szbrMargin, BOOL bHscroll, BOOL brefresh )
			: hWnd( hwnd )
			, bHScroll( bHscroll )
			, bRefresh( brefresh )
			, sTTLType( sttlType)
			, szTLMargin( sztlMargin )
			, sTBRType( stbrType )
			, szBRMargin( szbrMargin )
		{ };

	} SLAYOUT, *LPSLAYOUT;

	/*!< ı */
	typedef CTypedPtrList<CPtrList, LPSLAYOUT> CLayoutLst;					// LayoutListĶ


	/***********************************************************************************
	* ڲʹúĶ
	***********************************************************************************/
	/*!< 캯 */
	void Construct();

	/*!< ضĲԪ */
	LPSLAYOUT CResizableDialog::FindLayOut( HWND hWnd );	

private:

	BOOL			m_bShowGrip;			// ǷʾGrip
	BOOL			m_bUseMaxTrack;			// Ƿʹֵ׷
	BOOL			m_bUseMinTrack;			// ǷʹСֵ׷
	BOOL			m_bUseMaxRect;			// ǷƴڵĴС
	BOOL			m_bEnableSaveRestore;	// Ƿ񱣴洰ڵλúʹС
	BOOL			m_bInitDone;			// ǷѾʼ

	CString			m_cstrSection;			// ֶ
	CString			m_cstrEntry;			// ָ	

	CSize			m_szGripSize;			// GripĴС

	CRect			m_rcGripRect;			// GripķΧ

	POINT			m_ptMinTrackSize;		// ׷ٵСֵ
	POINT			m_ptMaxTrackSize;		// ׷ٵֵ
	POINT			m_ptMaxPos;				// ڵλ
	POINT			m_ptMaxSize;			// ڵĴС

	CLayoutLst		m_lstLayout;			// ҪԪص

};

#endif //__HW_RESIZABLEDIALOG_H__
